variables:
  TF_VAR_gitlab_username: "${GITLAB_USER_LOGIN}"
  TF_VAR_gitlab_password: "${GITLAB_ACCESS_TOKEN}"
  TF_VAR_gitlab_project_id: "${CI_PROJECT_ID}"
  TF_VAR_remote_address_base: "https://gitlab.com/api/v4/projects/${CI_PROJECT_ID}/terraform/state"
  TF_VAR_project_path: "${CI_PROJECT_PATH}"

# Set up environment variables for terraform
setup:
  stage: .pre
  script: |-
    if [ -z "${PROJECT}" ]; then 
        PROJECT=dirname $(git diff-tree -r --no-commit-id --name-only HEAD HEAD~1 | tail -1)
    else 
    cat <<EOF > build.env
    TF_STATE_NAME=$(echo $PROJECT | sed  's#/#__#')
    TF_CACHE_KEY=$(echo $PROJECT | sed  's#/#__#')
    TF_ROOT=${CI_PROJECT_DIR}/${PROJECT}
    CI_ENVIRONMENT=$PROJECT
    EOF
  artifacts:
    reports:
      dotenv: build.env
  rules:
    - changes:
      - terraform/*

# For `pre` jobs call the pipeline with the `process job`
trigger_process:
  stage: deploy
  variables:
    PROJECT: sed  's#/pre#/process#'
  trigger:
    include:
      - local: ${CI_PROJECT_DIR}/.gitlab-ci.yml
  rules:
  - if: $CI_ENVIRONMENT =~ /\/pre$/
    when: delayed
    start_in: '1 hours'
